<?php
/**
 * Copyright 2018 Kacper Donat
 *
 * @author Kacper "Kadet" Donat <kacper@kadet.net>
 *
 * Full license available in separate LICENSE file
 */

namespace Kadet\Functional\Reflection;


use function Kadet\Functional\reflect;

class ReflectionDecoratedFunction extends \ReflectionFunction
{
    public $reflection;
    public $decorated;

    public function __construct(callable $decorated)
    {
        $this->decorated  = $decorated;
        $this->reflection = reflect($decorated);
    }

    public function inNamespace()
    {
        return $this->reflection->inNamespace();
    }

    public function isClosure()
    {
        return $this->reflection->isVariadic();
    }

    public function isDeprecated()
    {
        return $this->reflection->isDeprecated();
    }

    public function isInternal()
    {
        return $this->reflection->isInternal();
    }

    public function isUserDefined()
    {
        return $this->reflection->isUserDefined();
    }

    public function getClosureThis()
    {
        return $this->reflection->getClosureThis();
    }

    public function getClosureScopeClass()
    {
        return $this->reflection->getClosureScopeClass();
    }

    public function getDocComment()
    {
        return $this->reflection->getDocComment();
    }

    public function getEndLine()
    {
        return $this->reflection->getEndLine();
    }

    public function getExtension()
    {
        return $this->reflection->getExtension();
    }

    public function getExtensionName()
    {
        return $this->reflection->getExtensionName();
    }

    public function getFileName()
    {
        return $this->reflection->getFileName();
    }

    public function getName()
    {
        return $this->reflection->getName();
    }

    public function getNamespaceName()
    {
        return $this->reflection->getNamespaceName();
    }

    public function getNumberOfParameters()
    {
        return $this->reflection->getNumberOfParameters();
    }

    public function getNumberOfRequiredParameters()
    {
        return $this->reflection->getNumberOfRequiredParameters();
    }

    public function getParameters()
    {
        return $this->reflection->getParameters();
    }

    public function getReturnType()
    {
        return $this->reflection->getReturnType();
    }

    public function getShortName()
    {
        return $this->reflection->getShortName();
    }

    public function getStartLine()
    {
        return $this->reflection->getStartLine();
    }

    public function getStaticVariables()
    {
        return $this->reflection->getStaticVariables();
    }

    public function hasReturnType()
    {
        return $this->reflection->hasReturnType();
    }

    public function returnsReference()
    {
        return $this->reflection->returnsReference();
    }

    public function isGenerator()
    {
        return $this->reflection->isGenerator();
    }

    public function isVariadic()
    {
        return $this->reflection->isVariadic();
    }
}