<?php
/**
 * Copyright 2018 Kacper Donat
 *
 * @author Kacper "Kadet" Donat <kacper@kadet.net>
 *
 * Full license available in separate LICENSE file
 */

namespace Kadet\Functional\Utils;


use Kadet\Functional\Decorator;

class MemoizedFunction implements Decorator
{
    private $decorated;
    private $memoized = [];

    public function __construct(callable $decorated)
    {
        $this->decorated = $decorated;
    }

    public function getDecorated(): callable
    {
        return $this->decorated;
    }

    public function __invoke(...$args)
    {
        $key = hash('sha256', print_r($args, true));

        if (!array_key_exists($key, $this->memoized)) {
            $this->memoized[$key] = ($this->decorated)(...$args);
        }

        return $this->memoized[$key];
    }
}